//----------------------------------------------------------------------------
// Mmedia.hpp - bcbdcc32 generated hdr (DO NOT EDIT) rev: 0
// From: Mmedia.pas
//----------------------------------------------------------------------------
#ifndef MmediaHPP
#define MmediaHPP
//----------------------------------------------------------------------------
#include <MMSystem.hpp>
#include <Graphics.hpp>
#include <ExtCtrls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <SysUtils.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <System.hpp>
namespace Mmedia
{
//-- type declarations -------------------------------------------------------
typedef void *PAVIFile;

typedef void *PGETFrame;

struct TAVIStream;
typedef TAVIStream *PAVIStream;

struct TAVIStream
{
	int fccType;
	int fccHandler;
	int dwFlags;
	int dwCaps;
	int dwScale;
	int dwRate;
	int dwStart;
	int dwLength;
	int dwInitialFrames;
	int dwSuggestedBufferSize;
	int dwQuality;
	int dwSampleSize;
	int dwEditCount;
	int dwFormatChangeCount;
	Word wPriority;
	Word wLanguage;
	Windows::TRect rcFrame;
	char Name[65];
} ;

struct TAVIFileInfo;
typedef TAVIFileInfo *PAVIFileInfo;

struct TAVIFileInfo
{
	int dwMaxBytesPerSec;
	int dwFlags;
	int dwCaps;
	int dwStreams;
	int dwSuggestedBufferSize;
	int dwWidth;
	int dwHeight;
	int dwScale;
	int dwRate;
	int dwLength;
	int dwEditCount;
	char szFileType[64];
} ;

struct TAVIStreamInfo;
typedef TAVIStreamInfo *PAVIStreamInfo;

struct TAVIStreamInfo
{
	int fccType;
	int fccHandler;
	int dwFlags;
	int dwCaps;
	Word wPriority;
	Word wLanguage;
	int dwScale;
	int dwRate;
	int dwStart;
	int dwLength;
	int dwInitialFrames;
	int dwSuggestedBufferSize;
	int dwQuality;
	int dwSampleSize;
	Windows::TRect rcFrame;
	char dwEditCount[64];
	char dwFormatChangeCount[64];
	char szName[64];
} ;

class __declspec(delphiclass) TTimeredComponent;
class __declspec(pascalimplementation) TTimeredComponent : public Classes::TPersistent
{
	typedef Classes::TPersistent inherited;
	
private:
	Word FInterval;
	Extctrls::TTimer* FTimer;
	void __fastcall SetInterval(Word p0);
	bool __fastcall GetTimered(void);
	
protected:
	virtual void __fastcall TimerTimer(System::TObject* p0) = 0;
	
public:
	__property Word Interval = {read=FInterval, write=SetInterval, default=0};
	__property bool Timered = {read=GetTimered, nodefault};
	__fastcall virtual TTimeredComponent(void);
	__fastcall virtual ~TTimeredComponent(void);
	virtual void __fastcall StartTimer(void);
	virtual void __fastcall StopTimer(void);
};

enum TMultimediaOption { mmPlayAVI, mmPlayWAV };

typedef Set<TMultimediaOption, mmPlayAVI, mmPlayWAV>  TMultimediaOptions;

class __declspec(delphiclass) TMultimedia;
class __declspec(pascalimplementation) TMultimedia : public TTimeredComponent
{
	typedef TTimeredComponent inherited;
	
private:
	void *FAVIFile;
	void *FFrame;
	TAVIStream *FVideoStream;
	System::AnsiString FAVIFileName;
	System::AnsiString FWAVFileName;
	int FMenuWindow;
	int FCallbackDC;
	int FWidth;
	int FHeight;
	int FLeft;
	int FTop;
	int FCurrent;
	int FLength;
	int FFrameWidth;
	int FFrameHeight;
	int FStartFrame;
	int FStopFrame;
	Graphics::TColor FBackColor;
	bool FActive;
	bool FDontStop;
	bool FEnabledClip;
	bool FAVIOnlyIfSel;
	bool FTransparent;
	Controls::TControl* FControl;
	TMultimediaOptions FOptions;
	void __fastcall SetAVIFileName( System::AnsiString p0);
	void __fastcall SetWAVFileName( System::AnsiString p0);
	void __fastcall SetOptions(TMultimediaOptions p0);
	void __fastcall SetActive(bool p0);
	void __fastcall PaintToDC(void);
	
protected:
	virtual void __fastcall TimerTimer(System::TObject* p0);
	
public:
	__fastcall virtual TMultimedia(void);
	__fastcall virtual ~TMultimedia(void);
	virtual void __fastcall Assign(Classes::TPersistent* p0);
	bool __fastcall PlayFile_WAV(bool p0);
	bool __fastcall OpenFile_AVI(void);
	Graphics::TBitmap* __fastcall GetFrame_AVI(int p0);
	void __fastcall CloseFile_AVI(void);
	virtual void __fastcall StartTimer(void);
	virtual void __fastcall StopTimer(void);
	__property int CallbackDC = {read=FCallbackDC, write=FCallbackDC, default=0};
	__property int Width = {read=FWidth, write=FWidth, default=0};
	__property int Height = {read=FHeight, write=FHeight, default=0};
	__property int FrameWidth = {read=FFrameWidth, default=0};
	__property int FrameHeight = {read=FFrameHeight, default=0};
	__property int Left = {read=FLeft, write=FLeft, default=0};
	__property int Top = {read=FTop, write=FTop, default=0};
	__property Graphics::TColor BackColor = {read=FBackColor, write=FBackColor, default=536870911};
	__property bool EnabledClip = {read=FEnabledClip, write=FEnabledClip, default=1};
	__property bool DontStop = {read=FDontStop, write=FDontStop, default=1};
	__property Controls::TControl* Control = {read=FControl, write=FControl, nodefault};
	
__published:
	__property System::AnsiString AVIFileName = {read=FAVIFileName, write=SetAVIFileName, nodefault};
	__property System::AnsiString WAVFileName = {read=FWAVFileName, write=SetWAVFileName, nodefault};
	__property TMultimediaOptions Options = {read=FOptions, write=SetOptions, default=0};
	__property bool Transparent = {read=FTransparent, write=FTransparent, default=0};
	__property bool AVIOnlyIfSel = {read=FAVIOnlyIfSel, write=FAVIOnlyIfSel, default=0};
	__property bool Active = {read=FActive, write=SetActive, default=0};
	__property Interval ;
};

//-- var, const, procedure ---------------------------------------------------
#define WM_DONEAVI (Word)(1224)
#define WM_SETAVI (Word)(1225)
extern void __fastcall finalization(void);
//-- template instantiations -------------------------------------------------
template class TMultimediaOptions ;

}	/* namespace Mmedia */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Mmedia;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// Mmedia
